import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    static long n;
    static TreeMap<Long, Long> parent = new TreeMap<>();
    static ArrayList<Long> invented = new ArrayList<>();

    static void bfs(long i) {
        Queue<Long> q = new LinkedList<>();
        q.add(i);
        parent.put(i, 0L);
        invented.add(i);
        while(!q.isEmpty()){
            long x = q.poll();
            if(x == n){
                Stack<Character> ans = new Stack<>();
                while(parent.get(x) != 0){
                    long y = parent.get(x);
                    if(y < x) ans.add('A');
                    else ans.add('B');
                    x = y;
                }
                while(!ans.isEmpty()){
                    out.print(ans.pop());
                }
                out.close();
                System.exit(0);
            }
            if(!invented.contains(3 * x + 1)){
                q.add(3 * x + 1);
                invented.add(3 * x + 1);
                parent.put(3 * x + 1, x);
            }
            if(!invented.contains(x / 2)){
                q.add(x / 2);
                invented.add(x / 2);
                parent.put(x / 2, x);
            }
        }
    }

    public static void main(String[] args) throws IOException {
        n = nextLong();
        bfs(1);
        out.println(-1);
        out.close();
    }

    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");


    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }

    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}