import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main {
    static long n;
    static TreeMap<Long, Long> parent = new TreeMap<>();
    static ArrayList<Long> invented = new ArrayList<>();

    static void bfs(long i) {
        Queue<Long> q = new LinkedList<>();
        q.add(i);
        parent.put(i, 0L);
        invented.add(i);
        while(!q.isEmpty()){
            long x = q.poll();
            if(x == 1){
                Queue<Character> ans = new LinkedList<>();
                while(parent.get(x) != 0){
                    long y = parent.get(x);
                    if(y > x) ans.add('A');
                    else ans.add('B');
                    x = y;
                }
                while(!ans.isEmpty()){
                    out.print(ans.poll());
                }
                out.close();
                System.exit(0);
            }
            if((x - 1) % 3 == 0 && !invented.contains((x - 1) / 3)){
                q.add((x - 1) / 3);
                invented.add((x - 1) / 3);
                parent.put((x - 1) / 3, x);
            }
            if(!invented.contains(x * 2)){
                q.add(x * 2);
                invented.add(x * 2);
                parent.put(x * 2, x);
            }
            if(!invented.contains(x * 2 + 1)){
                q.add(x * 2 + 1);
                invented.add(x * 2 + 1);
                parent.put(x * 2 + 1, x);
            }
        }
    }

    public static void main(String[] args) throws IOException {
        n = nextLong();
        bfs(n);
        out.println(-1);
        out.close();
    }


    static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out);
    static StringTokenizer in = new StringTokenizer("");

    public static boolean hasNext() throws IOException {
        if (in.hasMoreTokens()) return true;
        String s;
        while ((s = br.readLine()) != null) {
            in = new StringTokenizer(s);
            if (in.hasMoreTokens()) return true;
        }
        return false;
    }
    public static String nextToken() throws IOException {
        while (!in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
}